﻿/// <reference path="jsreference.js" />


function showAbout() {
    document.getElementById('aboutScrn').style.display = 'block';
}

function showAddStation() {
    wxbug.showStationSetup();
}

function showStation(id) {
    data.loadData(wxbug.right(id, 1));
}

function editStation(id) {
    wxbug.editStation(wxbug.right(id, 1));
}

function deleteStation(id) {
    document.getElementById('deleteStatConfirm').style.display = 'block';
    document.getElementById('deleteTxt').innerHTML = rf_delete + ': ' + myLocations.stations[wxbug.right(id, 1)].custName + '?';
    document.getElementById('delStationID').innerHTML = myLocations.stations[wxbug.right(id, 1)].id;
}
function cancelStationDelete() {
    document.getElementById('deleteStatConfirm').style.display = 'none';
}

function changeTempUnits(id) {

    try {
        var oldUnits = widget.preferenceForKey('settingsTemp');

        switch (id) {
        case 2200: //F
            widget.setPreferenceForKey('0', 'settingsTemp');
            break;
        case 2210: //C
            widget.setPreferenceForKey('1', 'settingsTemp');
            break;
        }
        if (oldUnits !== widget.preferenceForKey('settingsTemp')) {
            wxbug.loadStations();
        }
    }
    catch (err) {
        alert('Change Temp Error: ' + err.message);
    }
}
function changeWindUnits(id) {

    try {

        switch (id) {
        case 2300: //mph
            widget.setPreferenceForKey('0', 'settingsWndUnit');
            break;
        case 2310: //kmh
            widget.setPreferenceForKey('1', 'settingsWndUnit');
            break;
        case 2320: //kts
            widget.setPreferenceForKey('2', 'settingsWndUnit');
            break;
        case 2330: //ms
            widget.setPreferenceForKey('3', 'settingsWndUnit');
            break;
        }
        //reload stations
        data.loadData(widget.preferenceForKey('defaultLoc'));
        createMenu();
    }
    catch (err) {
        alert('Change Wind Error: ' + err.message);
    }
}

function delayShowGPS(id) {
    wxbug.showLoadingLoc();
    setTimeout('changeGPS(' + id + ')', 250);
}

function changeGPS(id) {

    try {

        switch (id) {
        case 2010: //on

            widget.setPreferenceForKey('1', 'myGPS');
            widget.setPreferenceForKey('0', 'defaultLoc');

            setTimeout('wxbug.loadStations()', 750);

            //no longer needed. moved to loadstations
            //wxbug.hideGPSSetup();
            //wxbug.hideStationSetup();

            break;
        case 2020: //off

            widget.setPreferenceForKey('0', 'myGPS');

            if (myLocations.stations.length === 1) {
                widget.setPreferenceForKey('', 'defaultLoc');
                document.getElementById('addStationCancel').style.display = 'none';
                wxbug.showGPSSetup();
            }
            else {
                widget.setPreferenceForKey('1', 'defaultLoc');
                setTimeout('data.loadData(widget.preferenceForKey("defaultLoc"))', 750);
            }
            wxbug.hideLoadingLoc();
            createMenu();
            break;
        }

    }
    catch (err) {

        alert('GPS Menu Error: ' + err.message);
        //set to off on error
        wxbug.showLoadingLoc();
        widget.setPreferenceForKey('0', 'myGPS');

        if (myLocations.stations.length === 1) {
            //just my location left
            //display the gps setup screen
            widget.setPreferenceForKey('', 'defaultLoc');
            document.getElementById('addStationCancel').style.display = 'none';
            wxbug.showGPSSetup();
        }
        else {
            widget.setPreferenceForKey('1', 'defaultLoc');
            setTimeout('data.loadData(widget.preferenceForKey("defaultLoc"))', 250);
        }
        createMenu();
    }
}

function createMenu() {

    window.menu.clear();

    // Create a Menu Object
    var locationMenu = window.menu;

    var optionAbout = new MenuItem(rf_about, 1000);
    locationMenu.append(optionAbout);
    optionAbout.onSelect = showAbout;

    if ((myLocations.stations.length > 1) | ((wxbug.gpsOn !== 0) & (widget.preferenceForKey('myGPS') === '1'))) {


        //temperature

        var currTempType = '';
        if (widget.preferenceForKey('settingsTemp') === '0') {
            currTempType = '(' + rf_degreesf + ')';
        }
        else if (widget.preferenceForKey('settingsTemp') === '1') {
            currTempType = '(' + rf_degreesc + ')';
        }

        var optionTempUnits = new MenuItem(rf_tempunits + ' ' + currTempType, 1010);
        locationMenu.append(optionTempUnits);

        var optionTempUnitsF = new MenuItem(rf_tempunits_eng, 2200);
        var optionTempUnitsC = new MenuItem(rf_tempunits_met, 2210);

        locationMenu.getMenuItemById(1010).append(optionTempUnitsF);
        locationMenu.getMenuItemById(1010).append(optionTempUnitsC);

        optionTempUnitsF.onSelect = changeTempUnits;
        optionTempUnitsC.onSelect = changeTempUnits;

        //wind units

        var currWindUnit = '';

        switch (widget.preferenceForKey('settingsWndUnit')) {
        case '0':
            currWindUnit = '(mph)';
            break;
        case '1':
            currWindUnit = '(km/h)';
            break;
        case '2':
            currWindUnit = '(kts)';
            break;
        case '3':
            currWindUnit = '(m/s)';
            break;

        }

        var optionWindSpeed = new MenuItem(rf_windspd_units + ' ' + currWindUnit, 1020);
        locationMenu.append(optionWindSpeed);

        var optionWindUnitsMPH = new MenuItem('mph', 2300);
        var optionWindUnitsKMH = new MenuItem('km/h', 2310);
        var optionWindUnitsKTS = new MenuItem('kts', 2320);
        var optionWindUnitsMS = new MenuItem('m/s', 2330);

        locationMenu.getMenuItemById(1020).append(optionWindUnitsMPH);
        locationMenu.getMenuItemById(1020).append(optionWindUnitsKMH);
        locationMenu.getMenuItemById(1020).append(optionWindUnitsKTS);
        locationMenu.getMenuItemById(1020).append(optionWindUnitsMS);

        optionWindUnitsMPH.onSelect = changeWindUnits;
        optionWindUnitsKMH.onSelect = changeWindUnits;
        optionWindUnitsKTS.onSelect = changeWindUnits;
        optionWindUnitsMS.onSelect = changeWindUnits;

    }

    if (widget.preferenceForKey('isGPS') === "true") {

        var currGPSType = '';

        var optionMyGPS = null;

        if (wxbug.gpsOn === 0) {
            optionMyGPS = new MenuItem(rf_mygps + ' (' + rf_disabled + ')', 1030);
            locationMenu.append(optionMyGPS);
        }
        else {

            if (widget.preferenceForKey('myGPS') === '1') {
                currGPSType = '(' + rf_on + ')';
            }
            else if (widget.preferenceForKey('myGPS') === '0') {
                currGPSType = '(' + rf_off + ')';
            }

            optionMyGPS = new MenuItem(rf_mygps + ' ' + currGPSType, 1030);
            locationMenu.append(optionMyGPS);

            var loc_MyGPSOn = new MenuItem(rf_on, 2010);
            var loc_MyGPSOff = new MenuItem(rf_off, 2020);

            locationMenu.getMenuItemById(1030).append(loc_MyGPSOn);
            locationMenu.getMenuItemById(1030).append(loc_MyGPSOff);

            loc_MyGPSOn.onSelect = delayShowGPS;
            loc_MyGPSOff.onSelect = delayShowGPS;
        }

    }

    var optionAddLocation = null;

    if (myLocations.stations.length <= 9) {
        optionAddLocation = new MenuItem(rf_add_loc, 1040);
        locationMenu.append(optionAddLocation);
        optionAddLocation.onSelect = showAddStation;
    }
    else {
        optionAddLocation = new MenuItem(rf_add_locmax, 1040);
        locationMenu.append(optionAddLocation);
    }

    for (var i = 1, len = myLocations.stations.length; i < len; ++i) {
        
        try {
        
            var stationid = Number(4000 + i);
            var optionStation = new MenuItem(myLocations.stations[i].custName, stationid);
            locationMenu.append(optionStation);

            var stationid = Number(4000 + i);

            var showID = Number(5100 + i);
            var editID = Number(5200 + i);
            var deleteID = Number(5300 + i);

            var statShow = new MenuItem(rf_show + ' ' + myLocations.stations[i].stationID, showID);
            var statEdit = new MenuItem(rf_edit + ' ' + myLocations.stations[i].stationID, editID);
            var statDelete = new MenuItem(rf_delete + ' ' + myLocations.stations[i].stationID, deleteID);

            locationMenu.getMenuItemById(stationid).append(statShow);
            statShow.onSelect = showStation;
            
            locationMenu.getMenuItemById(stationid).append(statEdit);
            statEdit.onSelect = editStation;

            locationMenu.getMenuItemById(stationid).append(statDelete);
            statDelete.onSelect = deleteStation;
            
        }
        catch (err) {
            alert('Menu Builder Error: ' + err.message);
        }

    }

}

