﻿/// <reference path="jsreference.js" />

var isConfig = false;
var configFile = '';
var isLoadingStat = false;

//Portrait Slider Variables
var panelStartLoc_p = 121;
var panelEndLoc_p = 488;
var panelLObsLoc_p = 355;

//Landscape Slider Variables
var panelStartLoc_l = 91;
var panelEndLoc_l = 358;
var panelLObsLoc_l = 242;

//Portrait Slider Horizontal Variables
var panelStartLoc_p_horiz = -360;
var panelEndLoc_p_horiz = 0;

//Landscape Slider Horizontal Variables
var panelStartLoc_l_horiz = -412;
var panelEndLoc_l_horiz = 0;

/*Config*/
var dataRefresh = 1800;
var isAd = false;
var adURL = '';

var settingsTemp = 0;
var settingsWndUnit = 1;
var settingsStations = [];
var stationsValue = [];
var myLocations = {};

function getResize() {
    wxbug.checkForAspect();
}

window.onresize = getResize;

//Displayed station values object
var CurrStation = {};

function wxbug() {

}

wxbug.currVersion = '2.0.4';
wxbug.feedBack = 'nokiawidget@aws.com';
wxbug.timeoutLen = 5000;
wxbug.timerOn = true;

//Slider defaults
wxbug.panelStartLoc = 0;
wxbug.panelEndLoc = 0;
wxbug.panelLObsLoc = 0;

wxbug.panelStartLoc_horiz = 0;
wxbug.panelEndLoc_horiz = 0;

//TempBar defaults
wxbug.TempBarHeight = 0;
wxbug.TempBarHeight_p = 120;
wxbug.TempBarHeight_l = 82;

wxbug.TempBarRangeC = 72.22;
wxbug.TempBarMaxC = 43.33;
wxbug.TempBarMinC = -28.88;
wxbug.TempBarOffsetC = 28.88;

wxbug.TempBarRangeF = 130;
wxbug.TempBarMaxF = 110;
wxbug.TempBarMinF = -20;
wxbug.TempBarOffsetF = 20;

wxbug.aspRatio = '';
wxbug.PollID = 0;
wxbug.Pollms = 1000;
wxbug.TimerID = 0;
wxbug.gpsOn = 1;

wxbug.PointerURL = 'http://datafeed.weatherbug.com/pointers/command/n/NokiaXPressMusic_v10xx.aspx';

window.widget.onshow = function() {

    //if the timer is running start it back up
    if (wxbug.TimerID) {
        wxbug.TimerID = setInterval('wxbug.dataTimer()', 10000);

        //If we have a station to update
        //Refresh the data if the widget was in the background
        ko = new Date();
        ji = ko.getTime();

        if (myLocations.stations.length == 1) { //only gps left

            //if not gps turned on prompt for setup
            if (widget.preferenceForKey('myGPS') == '1') {
                //gps on

                var timeDiff = ((Number(ji) - Number(widget.preferenceForKey("locUpdated_" + widget.preferenceForKey('defaultLoc')))) / 1000);

                if (timeDiff >= dataRefresh) {
                    wxbug.showLoadingLoc();
                    setTimeout('wxbug.loadStations()', 500);
                }
            }

        }
        else {

            var timeDiff = ((Number(ji) - Number(widget.preferenceForKey("locUpdated_" + widget.preferenceForKey('defaultLoc')))) / 1000);

            if (timeDiff >= dataRefresh) {
                wxbug.showLoadingLoc();
                setTimeout('wxbug.loadStations()', 500);
            }

        }

    }

    //    //start the aspect polling back up
    //    if (wxbug.PollID) {
    //        wxbug.PollID = setInterval('wxbug.checkForAspect()', wxbug.Pollms);
    //    }

}

window.widget.onhide = function() {
    clearInterval(wxbug.TimerID);
    clearInterval(wxbug.PollID);
}

wxbug.start = function() {

    //Load variables per resolution
    document.getElementById('splashTxt').innerHTML = rf_connect;
    wxbug.setAspRatio();
    document.getElementById('noConnect').style.display = 'none';
    document.getElementById('splashScrn').style.top = '0px';
    document.getElementById('splashScrn').style.left = '0px';
    document.getElementById('splashScrn').style.display = 'block';
    setTimeout('wxbug.initialize();', 1000);

}
wxbug.initialize = function() {

    wxbug.hideGPSSetup();

    ad.adMask();

    /* Obs, Forecast, Radar */
    document.getElementById('mainObs').style.left = 0;
    document.getElementById('mainObs').style.top = wxbug.panelLObsLoc;
    document.getElementById('mainForecast').style.left = 0;
    document.getElementById('mainForecast').style.top = wxbug.panelStartLoc;
    document.getElementById('mainRadar').style.left = 0;
    document.getElementById('mainRadar').style.top = wxbug.panelStartLoc;

    if (config.getConfigFile() == true) {
        //We have the config file in memory, load variables with data
        config.loadConfigSettings();
        wxbug.timerOn = true;
    }
    else {
        //no config file
        //show pop and ask to retry or display old data
        wxbug.timerOn = false;
        wxbug.noConnectMsg(0);
        return;
    }

    //Look for a wxBugGUID
    if (widget.preferenceForKey('wxBugGUID') != null) {
        //we have an ID proceed and call getCommand
        //connected user
        if (wxbug.getCommand(widget.preferenceForKey('wxBugGUID')) == 0) {
            //proceed
            wxbug.noConnectMsg(1);
            return;
        }
    }
    else {
        // need to setup the wxBugID
        // install get command
        var newUserID = wxbug.getCommand('');

        if (newUserID == 0) {
            wxbug.noConnectMsg(1);
            return;
        }

        widget.setPreferenceForKey(newUserID, 'wxBugGUID');
        //connected user
        wxbug.getCommand(widget.preferenceForKey('wxBugGUID'));

        //setup default settings on install
        //user can change after first station
        widget.setPreferenceForKey('0', 'myGPS');
        widget.setPreferenceForKey('0', 'settingsTemp');
        widget.setPreferenceForKey('0', 'settingsWndUnit');

        //clear any stored station data
        for (var i = 0, len = 10; i < len; ++i) {
            widget.setPreferenceForKey(null, 'station_' + i);
            widget.setPreferenceForKey(null, 'locUpdated_' + i);
        }

        widget.setPreferenceForKey(null, 'locationList');
    }

    document.getElementById('addStationCancel').innerHTML = rf_cancel;
    document.getElementById('addStationFindMe').innerHTML = rf_findme;
    document.getElementById('addStationCancel_land').innerHTML = rf_cancel;
    document.getElementById('addStationFindMe_land').innerHTML = rf_findme;

    document.getElementById('ActAlerts').innerHTML = rf_alerts;

    document.getElementById('deleteYes').innerHTML = rf_yes;
    document.getElementById('deleteNo').innerHTML = rf_no;

    //need to check if we are enabling gps
    if (widget.preferenceForKey('isGPS') == "false") {
        wxbug.gpsOn = 0;
        widget.setPreferenceForKey('0', 'myGPS');
    }

    //look for the defaultLoc if none then run setup
    //no default remove the cancel button

    if (widget.preferenceForKey('defaultLoc') == null | widget.preferenceForKey('defaultLoc') == '') {
        //No default location run setup, display GPS first
        document.getElementById('addStationCancel').style.display = 'none';
        document.getElementById('addStationCancel_land').style.display = 'none';

        if (isGPS == "true") {
            wxbug.showGPSSetup();
        }
        else {
            wxbug.showStationSetup();
        }
        document.getElementById('splashScrn').style.display = 'none';
    }
    else {
        //Create the menu and Load the data
        wxbug.showLoadingLoc();
        document.getElementById('splashScrn').style.display = 'none';
        setTimeout('wxbug.loadStations()', 500);
        ad.updateAd();
    }

}

wxbug.noConnectMsg = function(noConnectID) {

    document.getElementById('noConnect').style.display = 'block';

    switch (noConnectID) {
        case 0: //No config file
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_1;
            document.getElementById('noConnectBtn1').innerHTML = rf_retry;
            document.getElementById('noConnectBtn2').innerHTML = rf_cancel;
            document.getElementById('noConnectBtn2').style.display = 'block';

            document.getElementById('noConnectBtn1').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                setTimeout('wxbug.initialize()', 100);
            };

            document.getElementById('noConnectBtn2').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                data.loadData(widget.preferenceForKey("defaultLoc"));
            };
            break;
        case 1: //get command
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_1;
            document.getElementById('noConnectBtn1').innerHTML = rf_retry;
            document.getElementById('noConnectBtn2').innerHTML = rf_cancel;
            document.getElementById('noConnectBtn2').style.display = 'block';

            document.getElementById('noConnectBtn1').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                setTimeout('wxbug.initialize()', 100);
            };
            document.getElementById('noConnectBtn2').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                data.loadData(widget.preferenceForKey("defaultLoc"));
            };
            break;
        case 2: //could not get gps information
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_2;
            document.getElementById('noConnectBtn1').innerHTML = rf_retry;
            document.getElementById('noConnectBtn2').innerHTML = rf_cancel;
            document.getElementById('noConnectBtn2').style.display = 'block';

            document.getElementById('noConnectBtn1').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                setTimeout('wxbug.setupByGPS()', 100);
            };

            document.getElementById('noConnectBtn2').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                wxbug.showStationSetup();
            };

            break;
        case 3: //can't load station data
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_3;
            document.getElementById('noConnectBtn1').innerHTML = rf_retry;
            document.getElementById('noConnectBtn2').innerHTML = rf_cancel;
            document.getElementById('noConnectBtn2').style.display = 'block';

            document.getElementById('noConnectBtn1').onclick = function() {
                wxbug.showLoadingLoc();
                document.getElementById('noConnect').style.display = 'none';
                setTimeout('wxbug.loadStations()', 100);
            };

            document.getElementById('noConnectBtn2').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                wxbug.hideLoadingLoc();
            };
            break;
        case 4: //can't load station data from gps
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_3;
            document.getElementById('noConnectBtn1').innerHTML = rf_retry;
            document.getElementById('noConnectBtn2').innerHTML = rf_cancel;
            document.getElementById('noConnectBtn2').style.display = 'block';

            document.getElementById('noConnectBtn1').onclick = function() {
                wxbug.showLoadingLoc();
                document.getElementById('noConnect').style.display = 'none';
                wxbug.startGPSSetup();
            };

            document.getElementById('noConnectBtn2').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
                wxbug.hideLoadingLoc();
            };
            break;
        case 5: //can't retrieve gps data
            document.getElementById('noConnectID').innerHTML = noConnectID;
            document.getElementById('noConnectTxt').innerHTML = rf_noconnect_2;
            document.getElementById('noConnectBtn1').innerHTML = rf_ok;
            document.getElementById('noConnectBtn2').style.display = 'none';

            document.getElementById('noConnectBtn1').onclick = function() {
                document.getElementById('noConnect').style.display = 'none';
            };

            break;
    }

}

wxbug.loadStations = function() {

    isLoadingStat = true;

    wxbug.showLoadingLoc();

    try {

        //clear timer here and restart
        clearInterval(wxbug.TimerID);

        var MySettingsTem = widget.preferenceForKey('settingsTemp');
        var locURL = widget.preferenceForKey('locationURL');

        document.getElementById('splashScrn').style.display = 'none';

        myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');

        ko = new Date();
        ji = ko.getTime();

        var locationLen = (myLocations.stations.length);

        for (var i = 0, len = locationLen; i < len; ++i) {

            if (i == 0) {

                if (widget.preferenceForKey('myGPS') == '1') {

                    if (wxbug.gpsOn == 1) {

                        var thisLocation = {};

                        try {
                            thisLocation = getLocation();
                        }
                        catch (err) {
                            widget.preferenceForKey('myGPS') = '0';
                            wxbug.gpsOn = 0;
                        }

                        if (thisLocation != null) {

                            //alert("Lat: " + thisLocation.Lat);
                            //alert("Lon: " + thisLocation.Lon);

                            var mySearchLoc = {};

                            //check for GPS connection
                            mySearchLoc = wxbug.getJSONData(locURL + "?la=" + wxbug.showdec(thisLocation.Lat, 4) + "&lo=" + wxbug.showdec(thisLocation.Lon, 4));

                            if (String(mySearchLoc) == null) {
                                wxbug.noConnectMsg(3);
                                return;
                            }
                            else {
                                var myCityCode = '';
                                var myZipCode = '';
                                if (mySearchLoc.location.cityCode != null) {
                                    myCityCode = mySearchLoc.location.cityCode;
                                }

                                if (mySearchLoc.location.zipCode != null) {
                                    myZipCode = mySearchLoc.location.zipCode;
                                }

                                var gpsData = String(data.getData(i, MySettingsTem, myCityCode, myZipCode, ''));

                                if (gpsData != null) {
                                    widget.setPreferenceForKey(gpsData, 'station_0');
                                }
                            }
                        }
                        else
                        //gps is not working fix the UI
                        {
                            wxbug.hideLoadingLoc();
                            document.getElementById('addStationFindMe').style.display = 'none';
                            wxbug.gpsOn = 0;
                            widget.setPreferenceForKey('0', 'myGPS');

                            if (myLocations.stations.length > 1) {
                                createMenu();
                            }
                            wxbug.noConnectMsg(5);
                        }
                    }

                }
            }
            //not the gps location
            else {

                try {

                    var stationDataStr = String(data.getData(i, MySettingsTem, myLocations.stations[i].cityCode, myLocations.stations[i].zip, myLocations.stations[i].stationID));

                    //alert("i: " + i + " Temp Setting: " + MySettingsTem + " City: " + myLocations.stations[i].cityCode + " Zip: " + myLocations.stations[i].zip + " Station ID: " + myLocations.stations[i].stationID);
                    //alert("Load Station: " + stationDataStr);

                    if (stationDataStr == null) {
                        wxbug.noConnectMsg(3);
                        return;
                    }
                    else {
                        widget.setPreferenceForKey(stationDataStr, 'station_' + i);
                    }
                }
                catch (err) {
                    alert("Station Load Error: " + err.message);
                }

            }

            //set the last updated preference
            widget.setPreferenceForKey(ji, 'locUpdated_' + i);

        }

        dataRefresh = Number(widget.preferenceForKey('dataRefresh'));

        //testing datarefresh
        //dataRefresh = 45;

        //createMenu();
        data.loadData(widget.preferenceForKey('defaultLoc'));

        wxbug.hideGPSSetup();
        wxbug.hideStationSetup();

        wxbug.hideLoadingLoc();

        isLoadingStat = false;
        wxbug.TimerID = setInterval('wxbug.dataTimer()', 10000);

        ad.updateAd();

    }
    catch (err) {
        wxbug.hideLoadingLoc();
        //alert('Load Stations Error: ' + err.message);
        //clear timer here and restart
        clearInterval(wxbug.TimerID);
        isLoadingStat = false;
        wxbug.TimerID = setInterval('wxbug.dataTimer()', 10000);

    }
}

wxbug.editStation = function(id) {

    document.getElementById('editStationTitle').innerHTML = rf_edit_station;
    document.getElementById('editStationIDLoc').innerHTML = rf_id + ': ';
    document.getElementById('editStationID').innerHTML = myLocations.stations[id].stationID;
    document.getElementById('editStationLabel').innerHTML = rf_station_name + ': ' + myLocations.stations[id].custName;
    document.getElementById('editStatTxt').value = myLocations.stations[id].custName;
    document.getElementById('editStationSave').innerHTML = rf_save;
    document.getElementById('editStationSave_land').innerHTML = rf_save;
    document.getElementById('editStationCancel').innerHTML = rf_cancel;
    document.getElementById('editStationCancel_land').innerHTML = rf_cancel;
    document.getElementById('editScreen').style.display = 'block';

}

wxbug.saveStation = function() {

    //Take the cust name and adjust the location list value

    //we have a station list
    //loop through the list and add to the end
    myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');

    var newList = '';
    var editID;
    newList = '{ "stations": [ ';

    for (var i = 0, len = myLocations.stations.length; i < len; ++i) {
        if (myLocations.stations[i].stationID == document.getElementById('editStationID').innerHTML) {
            editID = i;
            newList += '{ "id": "' + i + '", "stationID": "' + myLocations.stations[i].stationID + '", "cityStCtry": "' + myLocations.stations[i].cityStCtry + '", "zip": "' + myLocations.stations[i].zip + '", "cityCode": "' + myLocations.stations[i].cityCode + '", "isUS": "' + myLocations.stations[i].isUS + '", "custName": "' + document.getElementById('editStatTxt').value + '", "lastUpdate": "' + myLocations.stations[i].lastUpdate + '" }, ';
        }
        else {
            newList += '{ "id": "' + i + '", "stationID": "' + myLocations.stations[i].stationID + '", "cityStCtry": "' + myLocations.stations[i].cityStCtry + '", "zip": "' + myLocations.stations[i].zip + '", "cityCode": "' + myLocations.stations[i].cityCode + '", "isUS": "' + myLocations.stations[i].isUS + '", "custName": "' + myLocations.stations[i].custName + '", "lastUpdate": "' + myLocations.stations[i].lastUpdate + '" }, ';
        }
    }

    //add new station
    newList += '] }';
    widget.setPreferenceForKey(newList, 'locationList');

    document.getElementById('editScreen').style.display = 'none';

    myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');

    data.loadData(editID);

    createMenu();
}

wxbug.deleteStationPre = function() {
    wxbug.showLoadingLoc();
    setTimeout('wxbug.deleteStation()', 250);
}

wxbug.deleteStation = function() {

    //loop through the list and add to the end
    myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');

    //get the station id to delete

    var stationDelID = document.getElementById('delStationID').innerHTML;

    var newList = '';
    var newRange = 0;
    newList = '{ "stations": [ ';

    for (var i = 0, len = myLocations.stations.length; i < len; ++i) {

        if (myLocations.stations[i].id != stationDelID) {
            newList += '{ "id": "' + newRange + '", "stationID": "' + myLocations.stations[i].stationID + '", "cityStCtry": "' + myLocations.stations[i].cityStCtry + '", "zip": "' + myLocations.stations[i].zip + '", "cityCode": "' + myLocations.stations[i].cityCode + '", "isUS": "' + myLocations.stations[i].isUS + '", "custName": "' + myLocations.stations[i].custName + '", "lastUpdate": "' + myLocations.stations[i].lastUpdate + '" }, ';
            newRange += 1;
        }
    }

    newList += '] }';

    document.getElementById('deleteStatConfirm').style.display = 'none';

    widget.setPreferenceForKey(newList, 'locationList');

    myLocations = eval('(' + newList + ')');

    if (myLocations.stations.length == 1) { //only gps left
        //if not gps turned on prompt for setup
        if (widget.preferenceForKey('myGPS') != '1') {
            //need to clear out data
            widget.setPreferenceForKey('', 'defaultLoc');
            document.getElementById('addStationCancel').style.display = 'none';
            document.getElementById('addStationCancel_land').style.display = 'none';
            
            if (wxbug.gpsOn == 1) {
                wxbug.showGPSSetup();
            }
            else {
                wxbug.showStationSetup();
            }
        }
        else {
            wxbug.showLoadingLoc();
            widget.setPreferenceForKey('0', 'defaultLoc');
            data.loadData('0');
        }
    }
    else {
        widget.setPreferenceForKey((newRange - 1), 'defaultLoc');
        wxbug.loadStations();
    }

    wxbug.hideLoadingLoc();
    createMenu();
    widget.setPreferenceForKey(null, "station_" + stationDelID);
    widget.setPreferenceForKey(null, "locUpdated_" + stationDelID);
}

wxbug.dataTimer = function() {

    if (Number(dataRefresh) <= 0) {

        if (isLoadingStat == false) {
            //refresh the data

            wxbug.showLoadingLoc();
            isLoadingStat = true;
            try {
                setTimeout('wxbug.loadStations()', 1000);
            }
            catch (err) {
                //alert("Timer Error: " + err.message);
                //dataRefresh = 45;
                dataRefresh = Number(widget.preferenceForKey('dataRefresh'));

            }
        }
    }

    //testing datarefresh
    document.getElementById('timerTxt').innerHTML = String(dataRefresh);

    dataRefresh -= 10;
}

wxbug.getCommand = function(UserID) {

    var URLappend = '';

    ko = new Date();
    ji = ko.getTime();

    if (UserID != '' && UserID != null) {
        URLappend = '?UserID=' + UserID + '&rnd=' + String(ji);
    }
    else {
        URLappend = '?rnd=' + String(ji);
    }

    var commandUserID = '';
    var versionNumb = '';
    var updateAvailable = 0;
    var updateURL = '';
    var emailfeedbackURL = '';
    var feedbackForumURL = '';
    var shareURL = '';

    var xmlhttp = null;
    xmlhttp = new XMLHttpRequest();
    var requestTimer = setTimeout(function() {
        xmlhttp.abort();
    }, wxbug.timeoutLen);
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            if (xmlhttp.status == 200) {
                clearTimeout(requestTimer);
                var response = xmlhttp.responseXML;
                var responseXML = xmlhttp.responseXML.documentElement;
                commandUserID = responseXML.getElementsByTagName('uid')[0].firstChild.data;
                document.getElementById('currVersion').innerHTML = rf_currentver + ': ' + wxbug.currVersion;
                document.getElementById('feedbackText').innerHTML = rf_feedback + ': ';
                document.getElementById('feedbackLink').innerHTML = wxbug.feedBack;
                document.getElementById('feedbackLink').href = 'mailto:' + wxbug.feedBack;
                document.getElementById('closeAbout').value = 'Close';

            } else {
                return 0;
            }
        }
        else {
            return 0;
        }
    }

    xmlhttp.open('GET', wxbug.PointerURL + URLappend, false);

    try {
        xmlhttp.send(null);
        return (commandUserID);
    }
    catch (err) {
        return 0;
    }
}

wxbug.aboutClose = function() {
    document.getElementById('aboutScrn').style.display = 'none';
}

wxbug.showAlertDetail = function() {
    document.getElementById('alertsDIV').style.display = 'block';
}

wxbug.hideAlertDetail = function() {
    document.getElementById('alertsDIV').style.display = 'none';
}

wxbug.showGPSSetup = function() {
    wxbug.hideLoadingLoc();
    wxbug.hideStationSetup();
    document.getElementById('setupStation').style.display = 'none';
    document.getElementById('setupGPSTitle').innerHTML = rf_setupGPSTitle;
    document.getElementById('setupGPSDesc').innerHTML = rf_setupGPSDesc;
    document.getElementById('setupGPSYes').innerHTML = rf_yes;
    document.getElementById('setupGPSNo').innerHTML = rf_no;
    document.getElementById('setupGPSYes_land').innerHTML = rf_yes;
    document.getElementById('setupGPSNo_land').innerHTML = rf_no;
    document.getElementById('setupGPS').style.display = 'block';


}
wxbug.hideGPSSetup = function() {
    document.getElementById('setupGPS').style.display = 'none';
    document.getElementById('gpsWorking').style.display = 'none';
}

wxbug.startGPSSetup = function() {
    if (wxbug.gpsOn == 1) {
        wxbug.showLoadingLoc();
        setTimeout('wxbug.setupByGPS()', 500);
    }
    else {
        wxbug.showStationSetup();
    }
}

wxbug.setupByGPS = function() {

    var thisLocation = getLocation();
    wxbug.showStationSetup();

    if (thisLocation != null) {

        var mySearchLoc = {};

        mySearchLoc = wxbug.getJSONData(widget.preferenceForKey('locationURL') + "?la=" + wxbug.showdec(thisLocation.Lat, 4) + "&lo=" + wxbug.showdec(thisLocation.Lon, 4));

        if (mySearchLoc == null) {
            wxbug.noConnectMsg(4);
            return;
        }
        else {
            // Loop through all the items
            for (iLoop = 0; iLoop < countryMenu.options.length; iLoop++) {
                if (countryMenu.options[iLoop].value == 'United States') {
                    if (mySearchLoc.location.country == 'USA') {
                        // Item is found. Set its selected property, and exit the loop
                        countryMenu.options[0].selected = true;
                        break;
                    }

                }
                else if (countryMenu.options[iLoop].value == mySearchLoc.location.country) {
                    // Item is found. Set its selected property, and exit the loop
                    countryMenu.options[iLoop].selected = true;
                    break;
                }
            }

            txtSearchString.value = mySearchLoc.location.city;

            //clear select items
            if (mySearchLoc.location.state != null) {
                for (iLoop = 0; iLoop < stateMenu.options.length; iLoop++) {
                    if (stateMenu.options[iLoop].value == mySearchLoc.location.state) {
                        // Item is found. Set its selected property, and exit the loop
                        stateMenu.options[iLoop].selected = true;
                        break;
                    }
                }
            }
            wxbug.searchCityZip(mySearchLoc.location.city);
        }

    }
    else {
        wxbug.hideLoadingLoc();
        document.getElementById('addStationFindMe').style.display = 'none';
        wxbug.gpsOn = 0;
        widget.setPreferenceForKey('0', 'myGPS');

        if (myLocations.stations.length > 1) {
            createMenu();
        }
        //alert("GPS Service object cannot be found.");
        wxbug.noConnectMsg(5);
    }
}

function getLocation() {
    // Obtain the Location service object
    try {
        //Service Object for GPS location service
        var so = device.getServiceObject("Service.Location", "ILocation");
        document.getElementById('addStationFindMe').style.display = 'block';
        wxbug.gpsOn = 1;
    } catch (ex) {

        wxbug.hideLoadingLoc();
        document.getElementById('addStationFindMe').style.display = 'none';
        wxbug.gpsOn = 0;
        widget.setPreferenceForKey('0', 'myGPS');
        //set the default loc to first location

        if (myLocations.stations.length > 1) {
            createMenu();
            widget.setPreferenceForKey(1, 'defaultLoc');
        }
        wxbug.noConnectMsg(5);
        return null;
    }

    try {
        var criteria = new Object();
        criteria.LocationInformationClass = "BasicLocationInformation";

        var GPSreturn = {};

        // Obtain the location information (synchronous)
        var result = so.ILocation.GetLocation(criteria);
        GPSreturn.Lat = result.ReturnValue.Latitude;
        GPSreturn.Lon = result.ReturnValue.Longitude;

        return GPSreturn;

    } catch (ex) {
        wxbug.hideLoadingLoc();
        document.getElementById('addStationFindMe').style.display = 'none';
        wxbug.gpsOn = 0;
        widget.setPreferenceForKey('0', 'myGPS');
        //set the default loc to first location

        if (myLocations.stations.length > 1) {
            createMenu();
            widget.setPreferenceForKey(1, 'defaultLoc');
        }

        wxbug.noConnectMsg(5);
        return null;
    }

}

wxbug.showLoadingLoc = function() {
    document.getElementById('gpsWorkingTxt').innerHTML = rf_loading + ' ' + rf_location;
    document.getElementById('gpsWorking').style.display = 'block';
}

wxbug.hideLoadingLoc = function() {
    document.getElementById('gpsWorking').style.display = 'none';
}

wxbug.showDeleteBox = function() {
    document.getElementById('gpsWorkingTxt').innerHTML = rf_loading + ' ' + rf_location;
    document.getElementById('gpsWorking').style.display = 'block';
}



wxbug.showStationSetup = function() {

    document.getElementById('stationSetupTitle').innerHTML = rf_setupStationTitle;
    document.getElementById('setupStation').style.display = 'block';
    document.getElementById('selectCountry').innerHTML = rf_selectcountry;
    document.getElementById('enterCity').innerHTML = rf_entercityorzipcode;
    document.getElementById('enterState').innerHTML = rf_state;
    document.getElementById('btnSearchCity').value = rf_search;
    document.getElementById('selectCity').innerHTML = rf_selectcity;
    document.getElementById('btnSelectCity').value = rf_select;
    document.getElementById('selectStation').innerHTML = rf_selectstation;
    document.getElementById('labelStation').innerHTML = rf_labelloc;
    document.getElementById('btnSaveStation').value = rf_save;
    document.getElementById('searchError').innerHTML = rf_not_found;

    document.getElementById('stationError').innerHTML = '';

    wxbug.toggleSearchItems(false);

    document.getElementById('enterCity').style.display = 'block';
    document.getElementById('txtSearchString').style.display = 'block';
    document.getElementById('btnSearchCity').style.display = 'block';
    document.getElementById('searchError').style.display = 'none';

    CountryMenuBuilder(document.getElementById("countryMenu"));
    StatesMenuBuilder(document.getElementById("stateMenu"));

    txtSearchString.value = '';

    wxbug.hideGPSSetup();

    if (wxbug.gpsOn == 1) {
        document.getElementById('addStationFindMe').style.display = 'block';
    }
    else {
        document.getElementById('addStationFindMe').style.display = 'none';
    }
}
wxbug.hideStationSetup = function() {
    document.getElementById('setupStation').style.display = 'none';
}
wxbug.hideStationEdit = function() {
    document.getElementById('editScreen').style.display = 'none';
}
wxbug.selectNewCountry = function() {
    if (countryMenu.value != '') {

        wxbug.toggleSearchItems(false);

        document.getElementById('stationError').innerHTML = '';

        if (countryMenu.value == 'United States') {

            document.getElementById('stateMenu').style.display = 'block';
            document.getElementById('enterState').style.display = 'block';
            document.getElementById('enterCity').innerHTML = rf_entercityorzipcode;
        }
        else {
            document.getElementById('stateMenu').style.display = 'none';
            document.getElementById('enterState').style.display = 'none';
            document.getElementById('enterCity').innerHTML = rf_entercity;
        }

        document.getElementById('enterCity').style.display = 'block';
        document.getElementById('txtSearchString').style.display = 'block';
        document.getElementById('btnSearchCity').style.display = 'block';

    }
    else {
        wxbug.toggleSearchItems(true);
    }

}

wxbug.selectCity = function() {

    //change the country menu to the selected city in the selectCityMenu array
    document.getElementById('selectStation').style.display = 'none';
    document.getElementById('selectStationMenu').style.display = 'none';
    document.getElementById('labelStation').style.display = 'none';
    document.getElementById('txtStationLabel').style.display = 'none';
    document.getElementById('btnSaveStation').style.display = 'none';
    document.getElementById('stationError').innerHTML = '';

    for (iLoop = 0; iLoop < countryMenu.options.length; iLoop++) {
        document.getElementById('stateMenu').style.display = 'block';
        document.getElementById('enterState').style.display = 'block';

        if (cityCountryMenuArray[selectCityMenu.selectedIndex] == 'USA') {
            countryMenu.options[0].selected = true;
            break;
        }
        else {
            document.getElementById('stateMenu').style.display = 'none';
            document.getElementById('enterState').style.display = 'none';
            if (countryMenu.options[iLoop].value == cityCountryMenuArray[selectCityMenu.selectedIndex]) {
                countryMenu.options[iLoop].selected = true;
                break;
            }
        }
    }
}

wxbug.searchCityZipPre = function(searchString) {
    wxbug.showLoadingLoc();
    setTimeout('wxbug.searchCityZip("' + searchString + '")', 250);
}

var cityCountryMenuArray = new Array();

wxbug.searchCityZip = function(searchString) {

    if (searchString != '') {

        document.getElementById('selectStation').style.display = 'none';
        document.getElementById('selectStationMenu').style.display = 'none';
        document.getElementById('labelStation').style.display = 'none';
        document.getElementById('txtStationLabel').style.display = 'none';
        document.getElementById('btnSaveStation').style.display = 'none';
        document.getElementById('stationError').innerHTML = '';

        //take country and search string and forward to json data call
        var modsearchstring = '';

        searchString = wxbug.trim(searchString);

        if (wxbug.IsNumeric(searchString)) {
            modsearchstring = wxbug.left(searchString, 5);
            document.getElementById('txtSearchString').value = modsearchstring;
        }

        else {
            if (countryMenu.value == 'United States') {
                modsearchstring = searchString + "," + stateMenu.value + ",USA";
                modsearchstring += '&ci=' + searchString;
                modsearchstring += '&st=' + stateMenu.value;
                modsearchstring += '&co=' + countryMenu.value;
            }
            else {
                modsearchstring = searchString + "," + countryMenu.value;
                modsearchstring += '&ci=' + searchString;
                modsearchstring += '&co=' + countryMenu.value;

            }
        }

        var mycityList = {};

        mycityList = wxbug.getJSONData(widget.preferenceForKey('locationsearchURL') + "?ss=" + modsearchstring);

        var rowCount = 0;

        //clear the list for multiple searches
        selectCityMenu.options.length = 0;

        if (mycityList.cityList != null) {
            for (var i = 0, len = mycityList.cityList.length; i < len; ++i) {

                var currentCity = '';

                if (mycityList.cityList[i].zipCode == null) {
                    currentCity = mycityList.cityList[i].cityCode;
                    selectCityMenu.options[selectCityMenu.options.length] = new Option(mycityList.cityList[i].city + ', ' + mycityList.cityList[i].country, mycityList.cityList[i].cityCode);
                }
                else {
                    currentCity = mycityList.cityList[i].zipCode;
                    selectCityMenu.options[selectCityMenu.options.length] = new Option(mycityList.cityList[i].city + ', ' + mycityList.cityList[i].state + ' ' + mycityList.cityList[i].country, mycityList.cityList[i].zipCode);
                }

                cityCountryMenuArray[i] = mycityList.cityList[i].country;

                ++rowCount;
            }

            for (iLoop = 0; iLoop < stateMenu.options.length; iLoop++) {
                if (stateMenu.options[iLoop].value == mycityList.cityList[0].state) {
                    stateMenu.options[iLoop].selected = true;
                    break;
                }
            }

            if (mycityList.cityList[0].country == 'USA') {
                countryMenu.options[0].selected = true;
                document.getElementById('stateMenu').style.display = 'block';
            }

            //if only one returned populate the stations list
            if (rowCount == 1) {
                wxbug.getStations(currentCity);
                document.getElementById('btnSelectCity').style.display = 'none';
            }
            else {
                document.getElementById('btnSelectCity').style.display = 'block';
            }

            document.getElementById('searchError').innerHTML = '';
            document.getElementById('searchError').style.display = 'none';
            document.getElementById('selectCityMenu').style.display = 'block';
            document.getElementById('selectCity').style.display = 'block';

        }
        else {
            document.getElementById('searchError').innerHTML = rf_not_found;
            document.getElementById('searchError').style.display = 'block';
            document.getElementById('selectCityMenu').style.display = 'none';
            document.getElementById('selectCity').style.display = 'none';
            document.getElementById('btnSelectCity').style.display = 'none';

            //hide the rest
            document.getElementById('selectStation').style.display = 'none';
            document.getElementById('selectStationMenu').style.display = 'none';
            document.getElementById('labelStation').style.display = 'none';
            document.getElementById('txtStationLabel').style.display = 'none';
            document.getElementById('btnSaveStation').style.display = 'none';
            document.getElementById('stationError').innerHTML = '';
        }

    }

    else {
        document.getElementById('searchError').innerHTML = rf_entercityorzipcode;
        document.getElementById('searchError').style.display = 'block';
    }

    wxbug.hideLoadingLoc();
}

var stationMenuArray = new Array();

wxbug.getStationsPre = function(citystationcode) {

    wxbug.showLoadingLoc();

    var getStationStr = 'wxbug.getStations("' + String(citystationcode) + '")';

    try {
        setTimeout(getStationStr, 250);
    }
    catch (err) {
        wxbug.hideLoadingLoc();
        alert(err.message);
    }
}

wxbug.getStations = function(code) {

    var mystationList = {};

    selectStationMenu.options.length = 0;

    if (widget.preferenceForKey('locationList') != '') {
        myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');
    }

    //they meant a US zip
    if (wxbug.IsNumeric(txtSearchString.value)) {
        countryMenu.selectedIndex = 0;
        document.getElementById('stateMenu').style.display = 'block';
        document.getElementById('enterState').style.display = 'block';
        document.getElementById('enterCity').innerHTML = rf_entercityorzipcode;
    }

    if (countryMenu.value == 'United States') {
        mystationList = wxbug.getJSONData(widget.preferenceForKey('stationURL') + "?zip=" + code);
    }
    else {
        mystationList = wxbug.getJSONData(widget.preferenceForKey('stationURL') + "?city=" + code);
    }

    if (mystationList.stationList != null) {

        //adjust the multi dim array count depending upon the duplicate station in mylocations
        var selectStationCount = 0;
        var myStationMatch = 0;

        for (var i = 0; i < mystationList.stationList.length; i++) {

            if (myLocations != null) {
                for (var j = 0, len = myLocations.stations.length; j < len; ++j) {

                    if (j != 0) {
                        //if the station is not in the current list increment
                        if (myLocations.stations[j].stationID == mystationList.stationList[i].id) {
                            myStationMatch += 1;
                        }
                    }
                }
            }
            selectStationCount += 1;
        }

        selectStationCount = selectStationCount - myStationMatch;

        for (var i = 0; i < selectStationCount; i++) {
            stationMenuArray[i] = new Array(9);
        }

        var s = 0;

        //we have the number just skip the stations already in the my station list
        for (var n = 0; n < mystationList.stationList.length; n++) {

            var isInStationList = false;

            if (myLocations != null) {

                for (var j = 0, len = myLocations.stations.length; j < len; ++j) {
                    if (j != 0) { //my location
                        //if the station is not in the current list
                        if (myLocations.stations[j].stationID == mystationList.stationList[n].id) {
                            isInStationList = true;
                        }
                    }
                }

            }

            if (isInStationList != true) {

                stationMenuArray[s][0] = mystationList.stationList[n].id; //station ID
                stationMenuArray[s][1] = mystationList.stationList[n].city; //city

                if (mystationList.stationList[n].isUs) {
                    selectStationMenu.options[selectStationMenu.options.length] = new Option(mystationList.stationList[n].name + ' (' + wxbug.showdec(mystationList.stationList[n].distance, 1) + ' ' + rf_miles + ')', mystationList.stationList[n].id);
                    stationMenuArray[s][2] = code;
                    stationMenuArray[s][3] = '';
                }
                else {
                    selectStationMenu.options[selectStationMenu.options.length] = new Option(mystationList.stationList[n].name, mystationList.stationList[n].id);
                    stationMenuArray[s][2] = '';
                    stationMenuArray[s][3] = code;
                }

                stationMenuArray[s][4] = mystationList.stationList[n].isUs; //isUS
                stationMenuArray[s][5] = mystationList.stationList[n].name; //custName
                stationMenuArray[s][6] = mystationList.stationList[n].state; //state
                stationMenuArray[s][7] = mystationList.stationList[n].country; //country
                stationMenuArray[s][8] = mystationList.stationList[n].distance; //distance

                s++;

            }
        }

        //if they add all the stations
        if (selectStationCount == 0) {
            document.getElementById('selectStationMenu').style.display = 'none';
            document.getElementById('btnSaveStation').style.display = 'none';
            document.getElementById('labelStation').style.display = 'none';
            document.getElementById('txtStationLabel').style.display = 'none';
            document.getElementById('selectStation').style.display = 'block';
            document.getElementById('selectStation').style.color = 'red';
            document.getElementById('selectStation').innerHTML = rf_stat_added;

        } else {

            //show the dropdown
            document.getElementById('selectStationMenu').style.display = 'block';
            document.getElementById('selectStation').innerHTML = rf_selectstation;
            document.getElementById('selectStation').style.display = 'block';
            document.getElementById('selectStation').style.color = 'black';
            document.getElementById('btnSaveStation').style.display = 'block';
            document.getElementById('labelStation').style.display = 'block';
            document.getElementById('txtStationLabel').style.display = 'block';
            document.getElementById('txtStationLabel').value = stationMenuArray[0][5];
        }
    }
    else {

        document.getElementById('selectStationMenu').style.display = 'none';
        document.getElementById('selectStation').style.display = 'none';
        document.getElementById('btnSaveStation').style.display = 'none';
        document.getElementById('labelStation').style.display = 'none';
        document.getElementById('txtStationLabel').style.display = 'none';
    }

    wxbug.hideLoadingLoc();
}

wxbug.addNewStationPre = function(stationIndex) {
    wxbug.showLoadingLoc();
    setTimeout('wxbug.addNewStation(' + stationIndex + ')', 250);
}

wxbug.addNewStation = function(stationIndex) {

    wxbug.showLoadingLoc();

    var myNewStation = {};

    document.getElementById('addStationCancel').style.display = 'block';
    document.getElementById('addStationCancel_land').style.display = 'block';

    var LocationName = '';
    LocationName = document.getElementById('txtStationLabel').value;

    if (LocationName == '' | LocationName == null) {
        LocationName = stationMenuArray[stationIndex][5];
    }

    if (widget.preferenceForKey('locationList') != null) {

        //we have a station list
        //loop through the list and add to the end
        myLocations = eval('(' + widget.preferenceForKey('locationList') + ')');

        var newList = '';
        newList = '{ "stations": [ ';
        var listCount = 0;

        for (var i = 0, len = myLocations.stations.length; i < len; ++i) {
            newList += '{ "id": "' + i + '", "stationID": "' + myLocations.stations[i].stationID + '", "cityStCtry": "' + myLocations.stations[i].cityStCtry + '", "zip": "' + myLocations.stations[i].zip + '", "cityCode": "' + myLocations.stations[i].cityCode + '", "isUS": "' + myLocations.stations[i].isUS + '", "custName": "' + myLocations.stations[i].custName + '", "lastUpdate": "' + myLocations.stations[i].lastUpdate + '" }, ';
            listCount += 1;
        }

        var locCityStateCountry = '';

        if (stationMenuArray[stationIndex][4] == true) {
            locCityStateCountry = stationMenuArray[stationIndex][1] + ', ' + stationMenuArray[stationIndex][6];
        }
        else {
            locCityStateCountry = stationMenuArray[stationIndex][1] + ', ' + stationMenuArray[stationIndex][7];
        }

        //add new station
        newList += '{ "id": "' + i + '", "stationID": "' + stationMenuArray[stationIndex][0] + '", "cityStCtry": "' + locCityStateCountry + '", "zip": "' + stationMenuArray[stationIndex][2] + '", "cityCode": "' + stationMenuArray[stationIndex][3] + '", "isUS": "' + stationMenuArray[stationIndex][4] + '", "custName": "' + LocationName + '", "lastUpdate": "" }, ';
        newList += '] }';

        widget.setPreferenceForKey(newList, 'locationList');
        document.getElementById('setupStation').style.display = 'none';
        widget.setPreferenceForKey(String(myLocations.stations.length), 'defaultLoc');

        setTimeout('wxbug.loadStations()', 500);

    }
    else {
        //no station list create one adding My Location 0 as well
        var newList = '';

        newList = '{ "stations": [ ';

        //add My Location
        newList += '{ "id": "0", "stationID": "", "cityStCtry": "", "zip": "", "cityCode": "", "isUS": "", "custName": "My Location", "lastUpdate": "" }, ';
        //add new station
        var locCityStateCountry = '';

        if (stationMenuArray[stationIndex][4] == true) {
            locCityStateCountry = stationMenuArray[stationIndex][1] + ', ' + stationMenuArray[stationIndex][6];
        }
        else {
            locCityStateCountry = stationMenuArray[stationIndex][1] + ', ' + stationMenuArray[stationIndex][7];
        }

        newList += '{ "id": "1", "stationID": "' + stationMenuArray[stationIndex][0] + '", "cityStCtry": "' + locCityStateCountry + '", "zip": "' + stationMenuArray[stationIndex][2] + '", "cityCode": "' + stationMenuArray[stationIndex][3] + '", "isUS": "' + stationMenuArray[stationIndex][4] + '", "custName": "' + LocationName + '", "lastUpdate": "" }, ';
        newList += '] }';

        widget.setPreferenceForKey(1, 'defaultLoc');
        widget.setPreferenceForKey(newList, 'locationList');
        document.getElementById('setupStation').style.display = 'none';

        setTimeout('wxbug.loadStations()', 500);

    }

    countryMenu.selectIndex = 0;
    stateMenu.selectIndex = 0;
    txtSearchString.value = "";
    document.getElementById('stateMenu').style.display = 'block';
    document.getElementById('enterState').style.display = 'block';

    //reset look to when first loaded
}

wxbug.setLabel = function(stationIndex) {
    document.getElementById('txtStationLabel').value = stationMenuArray[stationIndex][5];
}

wxbug.showdec = function(myNumber, NumberDec) {
    var cordec = Math.pow(10, NumberDec);
    myNumber = Math.round(myNumber * cordec) / cordec;
    return myNumber;
}

wxbug.IsNumeric = function(sText) {
    var ValidChars = "0123456789.";
    var IsNumber = true;
    var Char;


    for (i = 0; i < sText.length && IsNumber == true; i++) {
        Char = sText.charAt(i);
        if (ValidChars.indexOf(Char) == -1) {
            IsNumber = false;
        }
    }
    return IsNumber;

}

wxbug.left = function(str, n) {
    if (n <= 0) {
        return "";
    }
    else if (n > String(str).length) {
        return str;
    }
    else {
        return String(str).substring(0, n);
    }
}
wxbug.right = function(str, n) {
    if (n <= 0) {
        return "";
    }
    else if (n > String(str).length) {
        return str;
    }
    else {
        var iLen = String(str).length;
        return String(str).substring(iLen, iLen - n);
    }
}

wxbug.trim = function(stringToTrim) {
    return stringToTrim.replace(/^\s+|\s+$/g, "");
}

wxbug.toggleSearchItems = function(toggle) {
    if (toggle == true) {
        document.getElementById('enterCity').style.display = 'block';
        document.getElementById('txtSearchString').style.display = 'block';
        document.getElementById('btnSearchCity').style.display = 'block';
        document.getElementById('selectCityMenu').style.display = 'block';
        document.getElementById('selectCity').style.display = 'block';
        document.getElementById('btnSelectCity').value = rf_select;
        document.getElementById('btnSelectCity').style.display = 'block';
        document.getElementById('selectStation').style.display = 'block';
        document.getElementById('selectStationMenu').style.display = 'block';
        document.getElementById('labelStation').style.display = 'block';
        document.getElementById('txtStationLabel').style.display = 'block';
        document.getElementById('btnSaveStation').style.display = 'block';
    }
    else {
        document.getElementById('enterCity').style.display = 'none';
        document.getElementById('txtSearchString').style.display = 'none';
        document.getElementById('btnSearchCity').style.display = 'none';
        document.getElementById('selectCityMenu').style.display = 'none';
        document.getElementById('selectCity').style.display = 'none';
        document.getElementById('btnSelectCity').value = rf_select;
        document.getElementById('btnSelectCity').style.display = 'none';
        document.getElementById('selectStation').style.display = 'none';
        document.getElementById('selectStationMenu').style.display = 'none';
        document.getElementById('labelStation').style.display = 'none';
        document.getElementById('txtStationLabel').style.display = 'none';
        document.getElementById('btnSaveStation').style.display = 'none';
    }
}

wxbug.getJSONData = function(url) {

    ko = new Date();
    ji = ko.getTime();

    var response = '';
    var xmlhttp = null;
    xmlhttp = new XMLHttpRequest();
    var requestTimer = setTimeout(function() {
        xmlhttp.abort();
    }, wxbug.timeoutLen);
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            if (xmlhttp.status == 200) {
                clearTimeout(requestTimer);
                response = xmlhttp.responseText;
            } else {
                response = null;
            }
        }
    }
    xmlhttp.open('GET', url + '&rnd=' + String(ji), false);
    try {
        xmlhttp.send(null);
        return (eval('(' + response + ')'));
    }
    catch (err) {
        return null;
    }
}

wxbug.loadScreenVariables = function() {

    if (wxbug.aspRatio == 'p') {

        //Slider Variables
        wxbug.panelStartLoc = panelStartLoc_p;
        wxbug.panelEndLoc = panelEndLoc_p;
        wxbug.panelLObsLoc = panelLObsLoc_p;

        wxbug.panelStartLoc_horiz = panelStartLoc_p_horiz;
        wxbug.panelEndLoc_horiz = panelEndLoc_p_horiz;

        //TempBar variables
        wxbug.TempBarHeight = wxbug.TempBarHeight_p;

    }
    else {

        //Slider Variables
        wxbug.panelStartLoc = panelStartLoc_l;
        wxbug.panelEndLoc = panelEndLoc_l;
        wxbug.panelLObsLoc = panelLObsLoc_l;

        wxbug.panelStartLoc_horiz = panelStartLoc_l_horiz;
        wxbug.panelEndLoc_horiz = panelEndLoc_l_horiz;

        //TempBar variables
        wxbug.TempBarHeight = wxbug.TempBarHeight_l;

    }

}
//set initial load asp ratio
wxbug.setAspRatio = function() {
    if (window.innerWidth < window.innerHeight) {
        wxbug.changeAspect('p');
    }
    else {
        wxbug.changeAspect('l');
    }
    wxbug.loadScreenVariables();
    //wxbug.pollForAspect();

}
////start polling
//wxbug.pollForAspect = function() {
//    wxbug.PollID = setInterval('wxbug.checkForAspect()', wxbug.Pollms);
//}

wxbug.changeAspect = function(aspType) {
    //stop polling
    clearInterval(wxbug.PollID);
    //change the ratio type
    wxbug.aspRatio = aspType;

    //change the visual vars
    wxbug.loadScreenVariables();

    //switch out the css file
    if (wxbug.aspRatio == 'p') {

        wxbug.setActiveStyleSheet('portrait');

        if (document.getElementById('mainObs').style.top == panelLObsLoc_l + 'px') {
            document.getElementById('mainObs').style.top = panelLObsLoc_p + 'px';
        }
        else if (document.getElementById('mainObs').style.top == panelStartLoc_l + 'px') {
            document.getElementById('mainObs').style.top = panelStartLoc_p + 'px';
        }

        if (document.getElementById('mainForecast').style.top == panelEndLoc_l + 'px') {
            document.getElementById('mainForecast').style.top = panelEndLoc_p + 'px';
        }
        else if (document.getElementById('mainForecast').style.top == panelStartLoc_l + 'px') {
            document.getElementById('mainForecast').style.top = panelStartLoc_p + 'px';
        }

        if (document.getElementById('mainForecast').style.left == panelStartLoc_l_horiz + 'px') {
            document.getElementById('mainForecast').style.left = panelStartLoc_p_horiz + 'px';
        }

        if (document.getElementById('mainRadar').style.top == panelEndLoc_l + 'px') {
            document.getElementById('mainRadar').style.top = panelEndLoc_p + 'px';
        }
        else if (document.getElementById('mainRadar').style.top == panelStartLoc_l + 'px') {
            document.getElementById('mainRadar').style.top = panelStartLoc_p + 'px';
        }

        //change out the station buttons
        document.getElementById('r_btn').src = 'images/header/r_btn.png';
        document.getElementById('l_btn').src = 'images/header/l_btn.png';

    }
    else {

        //goig to landscape
        wxbug.setActiveStyleSheet('landscape');

        if (document.getElementById('mainObs').style.top == panelLObsLoc_p + 'px') {
            document.getElementById('mainObs').style.top = panelLObsLoc_l + 'px';
        }
        else if (document.getElementById('mainObs').style.top == panelStartLoc_p + 'px') {
            document.getElementById('mainObs').style.top = panelStartLoc_l + 'px';
        }

        if (document.getElementById('mainForecast').style.top == panelEndLoc_p + 'px') {
            document.getElementById('mainForecast').style.top = panelEndLoc_l + 'px';
        }
        else if (document.getElementById('mainForecast').style.top == panelStartLoc_p + 'px') {
            document.getElementById('mainForecast').style.top = panelStartLoc_l + 'px';
        }

        if (document.getElementById('mainForecast').style.left == panelStartLoc_p_horiz + 'px') {
            document.getElementById('mainForecast').style.left = panelStartLoc_l_horiz + 'px';
        }

        if (document.getElementById('mainRadar').style.top == panelEndLoc_p + 'px') {
            document.getElementById('mainRadar').style.top = panelEndLoc_l + 'px';
        }
        else if (document.getElementById('mainRadar').style.top == panelStartLoc_p + 'px') {
            document.getElementById('mainRadar').style.top = panelStartLoc_l + 'px';
        }

        //change out the station buttons
        document.getElementById('r_btn').src = 'images/header/rbtn_land.png';
        document.getElementById('l_btn').src = 'images/header/lbtn_land.png';

    }

    //wxbug.pollForAspect();

}

wxbug.setActiveStyleSheet = function(title) {
    var i, a, main;
    for (i = 0; (a = document.getElementsByTagName('link')[i]); i++) {
        if (a.getAttribute('rel').indexOf('stylesheet') != -1
        && a.getAttribute('title')) {
            a.disabled = true;
            if (a.getAttribute('title') == title) a.disabled = false;
        }
    }
}

wxbug.checkForAspect = function() {

    if (window.innerWidth < window.innerHeight) {
        if (wxbug.aspRatio == 'l') {
            wxbug.changeAspect('p');
            if (widget.preferenceForKey('defaultLoc') != '') {
                data.loadData(widget.preferenceForKey('defaultLoc'));
            }
        }
    }
    else {
        if (wxbug.aspRatio == 'p') {
            wxbug.changeAspect('l');
            if (widget.preferenceForKey('defaultLoc') != '') {
                data.loadData(widget.preferenceForKey('defaultLoc'));
            }
        }
    }
}

wxbug.loadDayForecast = function() {
    SlideHoriz('mainForecast', wxbug.panelEndLoc_horiz, wxbug.panelStartLoc_horiz);
}

wxbug.loadForecast = function() {

    document.getElementById('frcstBtnb').src = 'images/menu/btm_fc_on.png';
    document.getElementById('radarBtnb').src = 'images/menu/btm_rdr.png';
    document.getElementById('condsBtnb').src = 'images/menu/btm_cond.png';

    document.getElementById('frcstBtn').src = 'images/menu/hrz_fc_on.png';
    document.getElementById('radarBtn').src = 'images/menu/hrz_rdr.png';
    document.getElementById('condsBtn').src = 'images/menu/hrz_cond.png';

    document.getElementById('mainForecast').style.zIndex = 60;
    document.getElementById('mainRadar').style.zIndex = 50;
    Slide('mainForecast', wxbug.panelEndLoc, wxbug.panelStartLoc);
}

wxbug.loadRadar = function() {

    document.getElementById('frcstBtnb').src = 'images/menu/btm_fc.png';
    document.getElementById('radarBtnb').src = 'images/menu/btm_rdr_on.png';
    document.getElementById('condsBtnb').src = 'images/menu/btm_cond.png';

    document.getElementById('frcstBtn').src = 'images/menu/hrz_fc.png';
    document.getElementById('radarBtn').src = 'images/menu/hrz_rdr_on.png';
    document.getElementById('condsBtn').src = 'images/menu/hrz_cond.png';

    document.getElementById('mainRadar').style.zIndex = 60;
    document.getElementById('mainForecast').style.zIndex = 50;
    Slide('mainRadar', wxbug.panelEndLoc, wxbug.panelStartLoc);

}
wxbug.loadObs = function() {

    Slide('mainObs', wxbug.panelLObsLoc, wxbug.panelStartLoc);
}
wxbug.loadConds = function() {

    if (document.getElementById('mainObs').style.top == wxbug.panelStartLoc + 'px') {
        Slide('mainObs', wxbug.panelLObsLoc, wxbug.panelStartLoc);
    }

    if (document.getElementById('mainRadar').style.top == wxbug.panelStartLoc + 'px') {
        Slide('mainRadar', wxbug.panelEndLoc, wxbug.panelStartLoc);
    }

    if (document.getElementById('mainForecast').style.top == wxbug.panelStartLoc + 'px') {
        Slide('mainForecast', wxbug.panelEndLoc, wxbug.panelStartLoc);
    }

    document.getElementById('frcstBtnb').src = 'images/menu/btm_fc.png';
    document.getElementById('radarBtnb').src = 'images/menu/btm_rdr.png';
    document.getElementById('condsBtnb').src = 'images/menu/btm_cond_on.png';

    document.getElementById('frcstBtn').src = 'images/menu/hrz_fc.png';
    document.getElementById('radarBtn').src = 'images/menu/hrz_rdr.png';
    document.getElementById('condsBtn').src = 'images/menu/hrz_cond_on.png';

}

wxbug.setupOn = function(thisBtn) {
    if (wxbug.aspRatio == 'p') {
        document.getElementById(thisBtn).style.backgroundImage = "url(images/setup/okcncl_on.png)";
    }
    else {
        document.getElementById(thisBtn).style.backgroundImage = "url(images/setup/okcncl_land_on.png)";
    }

    setTimeout('wxbug.setupOff("' + thisBtn + '")', 500);
}

wxbug.setupOff = function(thisBtn) {
    if (wxbug.aspRatio == 'p') {
        document.getElementById(thisBtn).style.backgroundImage = "url(images/setup/okcncl.png)";
    }
    else {
        document.getElementById(thisBtn).style.backgroundImage = "url(images/setup/okcncl_land.png)";
    }

}

wxbug.stationUP = function() {
    try {

        wxbug.hideLoadingLoc();

        setTimeout('stationUPOff()', 500);

        var thisDefLoc = widget.preferenceForKey('defaultLoc');

        if ((Number(myLocations.stations.length) - 1) == Number(thisDefLoc)) {
            //we're at the top move to the first
            //is gps turned on 
            if (widget.preferenceForKey('myGPS') == '1') {
                data.loadData(0);
                thisDefLoc = 0;
            }
            else {
                data.loadData(1);
                thisDefLoc = 1;
            }
        }
        else {
            thisDefLoc = Number(thisDefLoc) + 1;
            data.loadData(thisDefLoc);
        }

        widget.setPreferenceForKey(thisDefLoc, 'defaultLoc');

        ad.updateAd();

    }
    catch (err) {
        alert('Station Up Error: ' + err.message);
    }
}

wxbug.stationDWN = function() {

    try {

        wxbug.hideLoadingLoc();

        setTimeout('stationDWNOff()', 500);

        var thisDefLoc = widget.preferenceForKey('defaultLoc');

        if (thisDefLoc == 0) {
            thisDefLoc = (myLocations.stations.length - 1);
            data.loadData(thisDefLoc);
        }
        else {
            //it's not My Location
            thisDefLoc -= 1;
            if (thisDefLoc == 0 && widget.preferenceForKey('myGPS') == 0) {
                thisDefLoc = (Number(myLocations.stations.length) - 1);
            }
            data.loadData(thisDefLoc);
        }

        widget.setPreferenceForKey(thisDefLoc, 'defaultLoc');

        ad.updateAd();

    }
    catch (err) {
        alert('Station Down Error: ' + err.message);
    }
}
function stationUPOn() {
    if (wxbug.aspRatio == 'p') {
        document.getElementById('r_btn').src = 'images/header/r_btn_on.png';
    }
    else {
        document.getElementById('r_btn').src = 'images/header/rbtn_land_on.png';
    }
}

function stationUPOff() {
    if (wxbug.aspRatio == 'p') {
        document.getElementById('r_btn').src = 'images/header/r_btn.png';
    }
    else {
        document.getElementById('r_btn').src = 'images/header/rbtn_land.png';
    }
}

function stationDWNOn() {
    if (wxbug.aspRatio == 'p') {
        document.getElementById('l_btn').src = 'images/header/l_btn_on.png';
    }
    else {
        document.getElementById('l_btn').src = 'images/header/lbtn_land_on.png';
    }
}

function stationDWNOff() {
    if (wxbug.aspRatio == 'p') {
        document.getElementById('l_btn').src = 'images/header/l_btn.png';
    }
    else {
        document.getElementById('l_btn').src = 'images/header/lbtn_land.png';
    }
}


